/*
 * hash.cpp
 *
 *  Created on: Mar 8, 2009
 *      Author: richardanton
 */

#include <iostream>

#include "memetype.h"
#include "memehash.h"
#include "meme.h"

class HashPrimitive : public MemePrimitive {
	private:
		MemeHash *deref(const Value& a);
	public:
		// these are not abstract, they all throw
		// errors if called on an object that does
		// not implement
		HashPrimitive();
		~HashPrimitive();

		virtual Value ini(const Value& x);

		virtual Value str(const Value& a);
		virtual Value num(const Value& a);

		virtual Value len(const Value& a);
		virtual Value idx(const Value& a, const Value& i);


};

MemePrimitive *getHashPrimitive(void)
{
	return new HashPrimitive();
}


MemeHash *HashPrimitive::deref(const Value& a) {
	return (MemeHash *)(a.ref_.target());
}

HashPrimitive::HashPrimitive()
{
}

HashPrimitive::~HashPrimitive()
{
}

Value HashPrimitive::ini(const Value& x)
{
	return x;
}

Value HashPrimitive::str(const Value& a)
{
	return deref(a)->toString();
}

Value HashPrimitive::len(const Value& a)
{
	return (int)deref(a)->count();
}

Value HashPrimitive::num(const Value& a)
{
	return (int)deref(a)->count();
}

Value HashPrimitive::idx(const Value& a, const Value& i)
{
	MemeHash *hash = deref(a);
	// return a ref to the array index
	MemeRef vref( &( hash->idx( i ) ) );
	return Value( valueRef, vref );
}


