
#ifndef __MEMEARRAY__
#include "memearray.h"
#endif

#include "meme.h"

// NOTE: reimpliment this with vector, list is going to be hideously stupid.

Value MemeArray::sOutOfBounds_; // returned for ref's when out of bounds

MemeArray::MemeArray(void) {
}

MemeArray::MemeArray(unsigned size) {
	resize( size );
}

Value& MemeArray::operator[] (int i) {
	return idx(i);
}

Value& MemeArray::idx(int i) {
	std::list<Value>::iterator it = elements_.begin();
	while( i-- )
		it++;
	// make sure nobody gets confused and tries to delete it
	it->untracked();
	return *it;
}


size_t MemeArray::count( void ) {
	return elements_.size();
}


void MemeArray::insert( int at, const Value& val) {
	std::list<Value>::iterator it = elements_.begin();
	while(at--)
		it++;
	elements_.insert( it, val );
	
}


void MemeArray::push( const Value& val ) {
	elements_.push_back( val );
}

void MemeArray::unshift( const Value& val ) {
	elements_.push_front( val );
}


Value MemeArray::pop(void) {
	Value v = elements_.back();
	elements_.pop_back();
	return v;
}
 // remove and return from back
Value MemeArray::shift(void) {
	Value v = elements_.front();
	elements_.pop_front();
	return v;
}
 // remove and return from front

Value& MemeArray::front(void) {
	return elements_.front();
}

Value& MemeArray::back(void) {
	return elements_.back();
}


// resize
void MemeArray::resize( size_t sz ) {
	elements_.resize( sz );
}


// erase
void MemeArray::erase( size_t idx, size_t count ) {
	std::list<Value>::iterator stop, start = elements_.begin();
	while(idx--)
		start++;
	stop = start;
	while(count--)
		stop++;
	elements_.erase( start, stop );
}

// convert to string
Value MemeArray::toString(void)
{
	MemeString *ms = new MemeString( "[" );
	std::list<Value>::iterator it = elements_.begin();
	while( it != elements_.end() )
	{
		if( it != elements_.begin() )
			ms->append(",");
		ms->append( it->toString() );
		it++;
	}
	ms->append( "]" );
	return Value(valueStr, MemeRef(ms));
}

// creates a new ref counted array
MemeRef MemeArray::newArray(void)
{
	MemeArray *arr = new MemeArray();
	if( !arr ) error( "out of memory" );
	return MemeRef( arr );
}

bool MemeArray::test(void) {
	// create an array
	MemeArray arr;
	arr.resize(5);
	arr[0] = 0;
	arr[1] = 10;
	arr[2] = 20;
	arr[3] = 30;
	arr[4] = 40;
	
	if( arr[2] != 20 )
		return false;

	// arr.toString().print();
	if( arr.toString() != Value(valueStr,MemeRef(MemeString::newString("[0,10,20,30,40]"))) ) 
		return false;

	arr.unshift( -10 );
	if( arr.front() != Value(-10) ) 	return false;
	if( arr.count() != 6 )         	return false; 
	if( arr.shift() != -10 ) return false;
	if( arr.count() != 5 ) return false;
	arr.push( 50 );
	if( arr.count() != 6 ) return false;

	arr.erase( 2 );
	if( arr.count() != 5 ) return false;
	if( arr[2] != 30 ) return false;
	if( arr[4] != 50 ) return false;

	arr.insert( 3, 35 );
	if( arr[3] != 35 ) return false;
	if( arr[4] != 40 ) return false;
	if( arr.count() != 6 ) return false;

	return true;
}

