
#include "memetype.h"

class NullPrimitive : public MemePrimitive {
	public:
		// these are not abstract, they all throw
		// errors if called on an object that does
		// not implement
		NullPrimitive();
		~NullPrimitive();

		// NOTE: this should have variable arguments
		virtual Value ini(const Value& x);

		virtual Value cmp(const Value& a, const Value& b);

		virtual Value str(const Value& a);
		virtual Value num(const Value& a);
		
};

MemePrimitive *getNullPrimitive(void)
{
	return new NullPrimitive();
}

// these are not abstract, they all throw
// errors if called on an object that does
// not implement
NullPrimitive::NullPrimitive()
{
}

NullPrimitive::~NullPrimitive()
{
}


// NOTE: this should have variable arguments
Value NullPrimitive::ini(const Value& x)
{
	return x;
}


Value NullPrimitive::cmp(const Value& a, const Value& b)
{
	return ( b.type == valueNull ? 0 : -1);
}

Value NullPrimitive::str(const Value& a)
{
	return Value(valueStr, MemeString::newString("(null)") );
}

Value NullPrimitive::num(const Value& a)
{
	return Value(0);
}

